        $MOD51

STACKTOP EQU    70H    ; start of stack (grows up)
LEDREG   EQU    0F000H ; LED register address
RNDGEN   EQU    0E000H ; address for reading random num. gen.
SEED     EQU    0C000H ; address for writing random num. gen. seed

        DSEG
        ORG     30H
CNTR:   DS      1      ; counter for wait routine

        CSEG
        ORG     0000H  ; program starts at 0 after reset
START:
        ; initialize stack pointer ...
        MOV     SP,#STACKTOP
        ; and the random number seed
        MOV     A,#1
        MOV     DPTR,#SEED
        MOVX    @DPTR,A
LOOP:
        ; read a new random number from the FPGA ...
        MOV     DPTR,#RNDGEN
        MOVX    A,@DPTR
        ; and show the random bits on the LED digit
        MOV     DPTR,#LEDREG
        MOVX    @DPTR,A       
        ; wait long enough so we can see the bits ...
        CALL    WAIT
        ; and then do it all again
        JMP     LOOP


; this subroutine waits about 1 second
WAIT:   
        PUSH    ACC
        PUSH    B
        MOV     cntr,#10
WAIT1:  
        MOV     B,#0
WAIT2:
        MOV     A,#0
        DJNZ    ACC,$
        DJNZ    B,WAIT2
        DJNZ    CNTR,WAIT1
        POP     B
        POP     ACC
        RET

        END
